summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rw-r--r--kernel.spec34
-rwxr-xr-xscripts/rawhide-rc.sh40
-rwxr-xr-xscripts/stable-update.sh24
3 files changed, 73 insertions, 25 deletions
diff --git a/kernel.spec b/kernel.spec
index 1d1b00827..ee1332d2e 100644
--- a/kernel.spec
+++ b/kernel.spec
@@ -57,6 +57,8 @@ Summary: The Linux kernel
%endif
# define buildid .local
+%define packager Thorsten Leemhuis https://fedoraproject.org/wiki/Kernel_Vanilla_Repositories
+%define buildid .vanilla.knurd.1
%if 0%{?fedora}
%define primary_target fedora
@@ -80,7 +82,8 @@ Summary: The Linux kernel
# For non-released -rc kernels, this will be appended after the rcX and
# gitX tags, so a 3 here would become part of release "0.rcX.gitX.3"
#
-%global baserelease 200
+%global baserelease 250
+
%global fedora_build %{baserelease}
# base_sublevel is the kernel version we're starting with and patching
@@ -91,12 +94,19 @@ Summary: The Linux kernel
## If this is a released kernel ##
%if 0%{?released_kernel}
+# Is it a -stable RC?
+%define stable_rc 0
+
# Do we have a -stable update to apply?
%define stable_update 15
# Set rpm version accordingly
%if 0%{?stable_update}
%define stablerev %{stable_update}
%define stable_base %{stable_update}
+%if 0%{?stable_rc}
+# stable RCs are incremental patches, so we need the previous stable patch
+%define stable_base %(echo $((%{stable_update} - 1)))
+%endif
%endif
%define rpmversion 5.%{base_sublevel}.%{stable_update}
@@ -127,7 +137,7 @@ Summary: The Linux kernel
# kernel PAE (only valid for ARM (lpae))
%define with_pae %{?_without_pae: 0} %{?!_without_pae: 1}
# kernel-debug
-%define with_debug %{?_without_debug: 0} %{?!_without_debug: 1}
+%define with_debug %{?_with_debug: 1} %{?!_with_debug: 0}
# kernel-doc
%define with_doc %{?_without_doc: 0} %{?!_without_doc: 1}
# kernel-headers
@@ -140,7 +150,7 @@ Summary: The Linux kernel
# bpf tool
%define with_bpftool %{?_without_bpftool: 0} %{?!_without_bpftool: 1}
# kernel-debuginfo
-%define with_debuginfo %{?_without_debuginfo: 0} %{?!_without_debuginfo: 1}
+%define with_debuginfo %{?_with_debuginfo: 1} %{?!_with_debuginfo: 0}
# Want to build a the vsdo directories installed
%define with_vdso_install %{?_without_vdso_install: 0} %{?!_without_vdso_install: 1}
# kernel-zfcpdump (s390 specific kernel for zfcpdump)
@@ -177,7 +187,7 @@ Summary: The Linux kernel
%define with_cross %{?_with_cross: 1} %{?!_with_cross: 0}
#
# build a release kernel on rawhide
-%define with_release %{?_with_release: 1} %{?!_with_release: 0}
+%define with_release %{?_without_release: 0} %{?!_without_release: 1}
# verbose build, i.e. no silent rules and V=1
%define with_verbose %{?_with_verbose: 1} %{?!_with_verbose: 0}
@@ -195,7 +205,7 @@ Summary: The Linux kernel
%define with_ipaclones %{?_without_ipaclones: 0} %{?!_without_ipaclones: 1}
# Want to build a vanilla kernel build without any non-upstream patches?
-%define with_vanilla %{?_with_vanilla: 1} %{?!_with_vanilla: 0}
+%define with_vanilla %{?_without_vanilla: 0} %{?!_without_vanilla: 1}
# Set debugbuildsenabled to 1 for production (build separate debug kernels)
# and 0 for rawhide (all kernels are debug kernels).
@@ -227,7 +237,12 @@ Summary: The Linux kernel
# pkg_release is what we'll fill in for the rpm Release: field
%if 0%{?released_kernel}
+%if 0%{?stable_rc}
+%define stable_rctag .rc%{stable_rc}
+%define pkg_release 0%{stable_rctag}.%{fedora_build}%{?buildid}%{?dist}
+%else
%define pkg_release %{fedora_build}%{?buildid}%{?dist}
+%endif
%else
@@ -290,7 +305,7 @@ Summary: The Linux kernel
%endif
%if %{nopatches}
-%define variant -vanilla
+#define variant -vanilla
%endif
%if !%{debugbuildsenabled}
@@ -777,6 +792,10 @@ Source1000: kernel-local
%define stable_patch_00 patch-5.%{base_sublevel}.%{stable_base}.xz
Source5000: %{stable_patch_00}
%endif
+%if 0%{?stable_rc}
+%define stable_patch_01 patch-3.%{base_sublevel}.%{stable_update}-rc%{stable_rc}.xz
+Patch01: %{stable_patch_01}
+%endif
# non-released_kernel case
# These are automagically defined by the rcrev and gitrev values set up
@@ -1539,6 +1558,9 @@ fi
xzcat %{SOURCE5000} | patch -p1 -F1 -s
git commit -a -m "Stable update"
%endif
+%if 0%{?stable_rc}
+ApplyPatch %{stable_patch_01}
+%endif
# Note: Even in the "nopatches" path some patches (build tweaks and compile
# fixes) will always get applied; see patch defition above for details
diff --git a/scripts/rawhide-rc.sh b/scripts/rawhide-rc.sh
index a4e15820a..c4e77ae42 100755
--- a/scripts/rawhide-rc.sh
+++ b/scripts/rawhide-rc.sh
@@ -1,19 +1,27 @@
#!/bin/sh
# Generate a commit for a rawhide RC release
+# update orgin
+~/usr/bin/vanilla-kernel-helper.sh masterupdate
+currentbranch=$(git symbolic-ref --short HEAD)
+if [[ "${currentbranch%-user-thl-vanilla-fedora}" == "rawhide" ]]; then
+ currentbranch="master"
+fi
+git merge --no-edit origin/${currentbranch%-user-thl-vanilla-fedora} || exit 1
+
source scripts/kernel-version.sh
-klist -s
-if [ ! $? -eq 0 ]; then
- echo "klist couldn't read the credential cache."
- echo "Do you need to fix your kerberos tokens?"
- exit 1
-fi
+#klist -s
+#if [ ! $? -eq 0 ]; then
+# echo "klist couldn't read the credential cache."
+# echo "Do you need to fix your kerberos tokens?"
+# exit 1
+#fi
-make release
+# make release
# fixup the release because rpmdev-bumpspec *sigh*
-scripts/fixup-bumpspec.sh
-fedpkg commit -c
+# scripts/fixup-bumpspec.sh
+# fedpkg commit -c
# Figure out what is our RC
RC=`grep "%global rcrev" kernel.spec| cut -d ' ' -f 3`
@@ -35,7 +43,10 @@ if [ ! -f patch-$MAJORVER.$BASE-rc$RC.xz ]; then
exit 1
fi
xz -9 patch-$MAJORVER.$BASE-rc$RC
- fedpkg upload patch-$MAJORVER.$BASE-rc$RC.xz
+ #fedpkg upload patch-$MAJORVER.$BASE-rc$RC.xz
+
+ checksum=$(sha512sum patch-$MAJORVER.$BASE-rc$RC.xz)
+ echo "SHA512 (patch-$MAJORVER.$BASE-rc$RC.xz) = ${checksum:0:128}" >> sources
fi
# bump rcrev in the spec and set git snapshot to 0
@@ -43,8 +54,11 @@ RC=$RC perl -p -i -e 's|%global rcrev.*|%global rcrev $ENV{'RC'}|' kernel.spec
perl -p -i -e 's|%define gitrev.*|%define gitrev 0|' kernel.spec
-perl -p -i -e 's|%global baserelease.*|%global baserelease 0|' kernel.spec
+perl -p -i -e 's|%global baserelease.*|%global baserelease 1|' kernel.spec
-rpmdev-bumpspec -c "Linux v$MAJORVER.$BASE-rc$RC" kernel.spec
+# rpmdev-bumpspec -c "Linux v$MAJORVER.$BASE-rc$RC" kernel.spec
+# echo "Don't forget to bump kernel-tools"
-echo "Don't forget to bump kernel-tools"
+git diff kernel.spec sources
+sleep 1 || exit 1
+git commit -m "Linux v$MAJORVER.$BASE-rc$RC" kernel.spec sources
diff --git a/scripts/stable-update.sh b/scripts/stable-update.sh
index 259a338c1..6169d3e86 100755
--- a/scripts/stable-update.sh
+++ b/scripts/stable-update.sh
@@ -1,5 +1,4 @@
#!/bin/sh
-#
# Author: Laura Abbott <labbott@fedoraproject.org>
#
# Apply a stable patch update to the Fedora tree. This takes care of
@@ -13,6 +12,11 @@
#
# Args: Stable version to update (e.g. 4.7.7, 4.8.1)
+# update orgin
+vanilla-kernel-helper.sh masterupdate
+currentbranch=$(git symbolic-ref --short HEAD)
+git merge --no-edit origin/${currentbranch%-user-thl-vanilla-fedora} || exit 1
+
if [ $# -lt 1 ]; then
echo "Need a version"
exit 1
@@ -61,12 +65,15 @@ fi
grep $1 sources &> /dev/null
if [ ! $? -eq 0 ]; then
- fedpkg upload patch-$1.xz
+ # thl is not an allowed uploader, skip this
+ # fedpkg upload patch-$1.xz
+ checksum=$(sha512sum patch-$1.xz)
+ echo "SHA512 (patch-$1.xz) = ${checksum:0:128}" >> sources
# Cryptic awk: search for the previous patch level (if one exists) and
# remove it from the source file
awk -v VER=$VERSION.$PATCHLEVEL.$((SUBLEVEL-1)) '$0 !~ VER { print $0; }' < sources > sources.tmp
- mv sources.tmp sources
+ mv sources.tmp sources
fi
# Update the stable level
@@ -77,8 +84,13 @@ awk -v STABLE=$SUBLEVEL '/%define stable_update/ \
mv kernel.spec.tmp kernel.spec
# Reset the base release for use with rpmdev-bumpspec
-BASERELEASE=`cat kernel.spec | grep "%global baserelease" | cut -d ' ' -f 3 | head -c 1`00
-BASERELEASE=$(($BASERELEASE-1))
+BASERELEASE=`cat kernel.spec | grep "%global baserelease" | cut -d ' ' -f 3 | head -c 1`50
+#BASERELEASE=$(($BASERELEASE-1))
BASERELEASE=$BASERELEASE perl -p -i -e 's|%global baserelease.*|%global baserelease $ENV{'BASERELEASE'}|' kernel.spec
-rpmdev-bumpspec -c "Linux v$1" kernel.spec
+# do not generate changelog: avoids merge conflicts that are not worth the trouble
+# rpmdev-bumpspec -c "Linux v$1" kernel.spec
+
+git diff kernel.spec sources
+sleep 1 || exit 1
+git commit -m "Linux v$1" kernel.spec sources